/*$Id: io.h,v 12.1 1998/10/16 20:52:37 al Exp $ -*- C++ -*-
 * shared data for all io functions
 * other io related stuff, like files and formatting
 */
#include "md.h"
#include "l_lib.h"
#ifndef IO_H
#define IO_H
/*--------------------------------------------------------------------------*/
class CS;
/*--------------------------------------------------------------------------*/
class OMSTREAM {
private:
  int mask;
  int fltwid;			/* max precision for float/double numbers */
  static int cpos[MAXHANDLE+1];	/* character counter */
  static bool Cipher;		/* flag: encrypt output file */
  static bool Pack;		/* flag: convert whitespace to tabs on out */
public:
  OMSTREAM(int m=0):mask(m),fltwid(7){}
  OMSTREAM & operator=(OMSTREAM x)	{mask = x.mask; return *this;}
  OMSTREAM & operator|=(OMSTREAM x)	{mask |= x.mask; return *this;}
  OMSTREAM & operator&=(OMSTREAM x)	{mask &= x.mask; return *this;}
  OMSTREAM & operator<<=(OMSTREAM x)	{mask <<= x.mask; return *this;}
  OMSTREAM operator&(OMSTREAM x)const	{return OMSTREAM(mask & x.mask);}
  OMSTREAM operator|(OMSTREAM x)const	{return OMSTREAM(mask | x.mask);}
  OMSTREAM operator~()const		{return OMSTREAM(~mask);}
  bool any()const			{return mask != 0;}
  bool cipher()const			{return Cipher;}
  bool pack()const			{return Pack;}
  OMSTREAM & setcipher(bool x=true)	{Cipher=x; return *this;}
  OMSTREAM & setpack(bool x=true)	{Pack=x;   return *this;}
  OMSTREAM & setfloatwidth(int x)	{fltwid=x; return *this;}
  OMSTREAM & reset()	{fltwid=7; Cipher=Pack=false; return *this;}
  /* out */
  OMSTREAM & operator<<(double x)	{return (*this)<<ftos(x,0,fltwid,0);}
  OMSTREAM & operator<<(int x)		{return form("%d", x);}
  OMSTREAM & operator<<(unsigned x)	{return form("%u", x);}
  OMSTREAM & operator<<(char c);
  OMSTREAM & operator<<(const char* s);
  OMSTREAM & tab(int);
  OMSTREAM & form(const char*,...);
};
inline bool any(OMSTREAM m) {return m.any();}
const char* octal(int x);
/*--------------------------------------------------------------------------*/
class IO {
public:
  static OMSTREAM mstdout;
  static OMSTREAM error;
  static OMSTREAM out;		/* where to send data, multi-format */
  static OMSTREAM plotout;	/* where to send ascii graphics (actual) */
  static bool plotset;		/* plot on by default flag */
  static int formaat;		/* how to format io.  Basic option. */
  static FILE *whence;		/* get file from.  std C file. */
  static bool suppresserrors;
  static bool incipher;		/* flag: decrypt input file */
  static FILE *stream[MAXHANDLE+1];	/* reverse of fileno() */
};
/*--------------------------------------------------------------------------*/
/* contrl */	void	initio(OMSTREAM,FILE*);
		void	decipher(char*);
		void	outreset();
		OMSTREAM outset(CS&,const char*,const char*);
/* findf */	char*	findfile(const char*,const char*,int);
/* getln */	char* 	getlines(char*,int,FILE*);
/* xopen */	void	xclose(FILE**);
		FILE*	xopen(CS&,const char*,const char*);
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
