/*$Id: io_contr.cc,v 12.1 1998/10/16 20:53:15 al Exp $ -*- C++ -*-
 * Sets up output direction and format for most commands
 * updates pointers into the string
 * outreset starts it all over
 */
#include "ap.h"
#include "error.h"
#include "l_lib.h"
#include "io.h"
/*--------------------------------------------------------------------------*/
	void	initio(int,FILE*);
	void	decipher(char*);
	void	outreset(void);
	OMSTREAM outset(CS&,const char*,const char*);
static	FILE*	file_open(CS&,const char*,const char*,FILE*);
/*--------------------------------------------------------------------------*/
static FILE *fn;		/* write file				    */
/*--------------------------------------------------------------------------*/
/* initio: initialize file encryption, etc
 */
void initio(OMSTREAM Where, FILE *Whence)
{
  const char* tag = "''''";
  if (Where.cipher())			/* if writing an encrypted file,    */
    Where << tag << '\n';		/* mark it as encrypted		    */
  if (Whence){
    char buf[BUFLEN];
    if (!fgets(buf, BUFLEN, Whence))	/* if the first line deciphers to   */
      return;				/* the cipher tag, it is encrypted  */
    IO::incipher = true;		/* otherwise,			    */
    decipher(buf);			/*	 rewind and read normally   */
    if (strcmp(buf,tag) != 0){		/* mismatch */
      IO::incipher = false;
      fseek(Whence,0L,SEEK_SET);
    }
  }
}
/*--------------------------------------------------------------------------*/
/* decipher: un-encrypt a line of text in place
 */
void decipher(char *buf)
{
  if (IO::incipher){
    for ( ; isprint(buf[1]); buf++ ){
      int fixed = (int)buf[1] - (int)buf[0];
      while (!isascii(fixed) || !isprint(fixed))
	fixed += (0x7f-0x20);
      buf[0] = (char)fixed;
    }
    buf[0] = '\0';
  }
}
/*--------------------------------------------------------------------------*/
/* outreset: close files and set i/o flags to standard values
 */
void outreset(void)
{
  xclose(&fn);
  xclose(&IO::whence);
  IO::formaat = 0;
  IO::incipher = false;
  IO::mstdout = 2;
  IO::mstdout.reset();
}
/*--------------------------------------------------------------------------*/
/* outset: set up i/o for a command
 * return whether or not it did anything
 */
OMSTREAM outset(CS& cmd, const char *inext, const char *outext)
{
  bool retcode = false;
  OMSTREAM out = IO::mstdout;
  for (;;){
    if (cmd.pmatch("Basic")){
      IO::formaat = ftos_EXP;
    }else if (cmd.pmatch("Cipher")){
      out.setcipher().setpack();
    }else if (cmd.pmatch("Pack")){
      out.setpack();
    }else if (cmd.pmatch("Quiet")){
      out &= ~IO::mstdout;
    }else if (cmd.pmatch("Echo") || cmd.pmatch("List")){
      out |= IO::mstdout;
    }else if (outext && cmd.pmatch("SAve")){
      fn = file_open(cmd,outext,"w",fn);
      out |= 1<<fileno(fn);
    }else if (outext && cmd.pmatch(">$$")){
      const char *rwaflag;
      rwaflag = (cmd.pmatch(">$$")) ? "a" : "w";
      fn = file_open(cmd,outext,rwaflag,fn);
      out |= 1<<fileno(fn);
      IO::formaat = ftos_EXP;
    }else if (inext && cmd.pmatch("<$$")){
      IO::whence = file_open(cmd,inext,"r",IO::whence);
    }else{
      break;
    }
    retcode = true;
  }
  IO::out = out;
  return out;
}
/*--------------------------------------------------------------------------*/
/* file_open: a different interface for xopen
 */
static FILE *file_open(
	CS& cmd,
	const char *ext,
	const char *rwaflag,
	FILE *fileptr)
{
  xclose(&fileptr);
  fileptr = xopen(cmd,ext,rwaflag);
  if (!fileptr)
    error(bERROR, "");
  return fileptr;
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
