/*$Id: l_aqueue.h,v 11.26 1996/02/29 22:28:17 al Exp $ -*- C++ -*-
 * A queue class, circular array
 */
#ifndef M_AQUEUE_H
#define M_AQUEUE_H
#include "md_bool.h"
/*--------------------------------------------------------------------------*/
template <class T>
class AQUEUE {
private:
  T  	  *q;           // storage array, allocated with "new"
  int     size;         // how big is it
  int     front;        // where objects leave from
  int	  rear;		// the first empty slot
public:
	     AQUEUE(int s=100)
	       {q = new T[s]; assert(q); front = rear = 0; size = s;}
             ~AQUEUE()		{delete [] q;}
  int        Count()const	{return (size+rear-front)%size;}
  int        Capacity()const	{return size-1;}
  int        SpaceLeft()const	{return Capacity()-Count();}
  AQUEUE<T>& Clear()		{front = rear; return *this;}
  bool       IsEmpty()const	{return Count()==0;}
  bool       IsFull()const	{return SpaceLeft()==0;}
  AQUEUE<T>& Enqueue(T x)
		{assert(!IsFull()); q[rear++]=x; rear%=size; return *this;}
  AQUEUE<T>& operator<<(T x)	{return Enqueue(x);}
  AQUEUE<T>& DelFront()
		{assert(!IsEmpty()); ++front; front%=size; return *this;}
  T	     Dequeue()
		{assert(!IsEmpty()); T& m=q[front++]; front%=size; return m;}
  AQUEUE<T>& operator>>(T& x)	{x = Dequeue(); return *this;}
  T	     Front()		{assert(!IsEmpty()); return q[front];}
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
