/*$Id: s__out.cc,v 12.1 1998/10/16 20:53:15 al Exp $ -*- C++ -*-
 * tr,dc analysis output functions (and some ac)
 */
#include "constant.h"
#include "io.h"
#include "l_lib.h"
#include "u_status.h"
#include "u_probe.h"
#include "s__.h"
#include "declare.h"	/* plottr, plopen */
/*--------------------------------------------------------------------------*/
//	void	SIM::outdata(double);
//	void	SIM::head(double,double,bool,const char*);
//	void	SIM::print(double);
//	void	SIM::alarm(void);
//	void	SIM::store(void);
/*--------------------------------------------------------------------------*/
/* SIM::out: output the data, "keep" for ac reference
 */
void SIM::outdata(double x)
{
  STATUS::output.start();
  plottr(x);
  print(x);
  alarm();
  store();
  STATUS::iter[iPRINTSTEP] = 0;
  STATUS::control[cSTEPS] = 0;
  STATUS::output.stop();
}
/*--------------------------------------------------------------------------*/
/* SIM::head: print column headings and draw plot borders
 */
void SIM::head(double start, double stop, bool linear, const char *col1)
{
  if (!plopen(mode,start,stop,linear)){
    if (col1  &&  *col1)
      out.form("#%-10s", col1);
    for (int ii = 0;  ii < printlist.count();  ii++){
      out.form(" %-10.10s", printlist[ii].label());
    }
    out << '\n';
  }
}
/*--------------------------------------------------------------------------*/
/* SIM::print: print the list of results (text form) to out
 * The argument is the first column (independent variable, aka "x")
 */
void SIM::print(double x)
{
  if (!IO::plotout.any()){
    if (x != NOT_VALID)
      out << ftos(x, 11, 5, IO::formaat);
    for (int ii = 0;  ii < printlist.count();  ii++){
      double value = printlist[ii].value();
      out << ftos(value, 11, 5, IO::formaat);
    }
    out << '\n';
  }
}
/*--------------------------------------------------------------------------*/
/* SIM::alarm: print a message when a probe is out of range
 */
void SIM::alarm(void)
{
  for (int ii = 0;  ii < alarmlist.count();  ii++){
    PROBE& prb = alarmlist[ii];
    double value = prb.value();
    if (prb.inrange()){
      out << prb.label() << '='
	  << ftos(value, 11, 5, IO::formaat) << '\n';
    }
  }
}
/*--------------------------------------------------------------------------*/
/* SIM::store: a stub: will be store data in preparation for post processing
 */
void SIM::store(void)
{
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
